/* contacts-store.c generated by valac 0.40.4, the Vala compiler
 * generated from contacts-store.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 8 -*- */
/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <folks/folks.h>
#include <telepathy-glib/telepathy-glib.h>
#include <glib/gstdio.h>
#include <gio/gio.h>


#define CONTACTS_TYPE_STORE (contacts_store_get_type ())
#define CONTACTS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_STORE, ContactsStore))
#define CONTACTS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_STORE, ContactsStoreClass))
#define CONTACTS_IS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_STORE))
#define CONTACTS_IS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_STORE))
#define CONTACTS_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_STORE, ContactsStoreClass))

typedef struct _ContactsStore ContactsStore;
typedef struct _ContactsStoreClass ContactsStoreClass;
typedef struct _ContactsStorePrivate ContactsStorePrivate;

#define CONTACTS_TYPE_CONTACT (contacts_contact_get_type ())
#define CONTACTS_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_CONTACT, ContactsContact))
#define CONTACTS_CONTACT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_CONTACT, ContactsContactClass))
#define CONTACTS_IS_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_CONTACT))
#define CONTACTS_IS_CONTACT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_CONTACT))
#define CONTACTS_CONTACT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_CONTACT, ContactsContactClass))

typedef struct _ContactsContact ContactsContact;
typedef struct _ContactsContactClass ContactsContactClass;
enum  {
	CONTACTS_STORE_0_PROPERTY,
	CONTACTS_STORE_AGGREGATOR_PROPERTY,
	CONTACTS_STORE_BACKEND_STORE_PROPERTY,
	CONTACTS_STORE_CALLER_ACCOUNT_PROPERTY,
	CONTACTS_STORE_IS_QUIESCENT_PROPERTY,
	CONTACTS_STORE_IS_PREPARED_PROPERTY,
	CONTACTS_STORE_NUM_PROPERTIES
};
static GParamSpec* contacts_store_properties[CONTACTS_STORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ContactsContactPrivate ContactsContactPrivate;
typedef struct _Block3Data Block3Data;
typedef struct _ContactsStoreFindContactData ContactsStoreFindContactData;
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
typedef struct _ContactsStoreCheckCallCapabilitiesData ContactsStoreCheckCallCapabilitiesData;
typedef struct _ContactsStoreCheckAccountCapsData ContactsStoreCheckAccountCapsData;
enum  {
	CONTACTS_STORE_CHANGED_SIGNAL,
	CONTACTS_STORE_ADDED_SIGNAL,
	CONTACTS_STORE_REMOVED_SIGNAL,
	CONTACTS_STORE_QUIESCENT_SIGNAL,
	CONTACTS_STORE_PREPARED_SIGNAL,
	CONTACTS_STORE_EDS_PERSONA_STORE_CHANGED_SIGNAL,
	CONTACTS_STORE_NUM_SIGNALS
};
static guint contacts_store_signals[CONTACTS_STORE_NUM_SIGNALS] = {0};

struct _ContactsStore {
	GObject parent_instance;
	ContactsStorePrivate * priv;
	GeeHashMultiMap* dont_suggest_link;
};

struct _ContactsStoreClass {
	GObjectClass parent_class;
};

struct _ContactsStorePrivate {
	FolksIndividualAggregator* _aggregator;
	GeeArrayList* contacts;
	TpAccount* _caller_account;
};

struct _ContactsContact {
	GObject parent_instance;
	ContactsContactPrivate * priv;
	ContactsStore* store;
	gboolean is_main;
	FolksIndividual* individual;
	FolksPersona* fake_persona;
};

struct _ContactsContactClass {
	GObjectClass parent_class;
};

typedef gboolean (*ContactsStoreContactMatcher) (ContactsContact* c, void* user_data);
struct _Block3Data {
	int _ref_count_;
	ContactsStore* self;
	ContactsContact* matched;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	ContactsStoreContactMatcher matcher;
	gpointer matcher_target;
	gpointer _async_data_;
};

struct _ContactsStoreFindContactData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactsStore* self;
	ContactsStoreContactMatcher matcher;
	gpointer matcher_target;
	ContactsContact* result;
	Block3Data* _data3_;
	GeeArrayList* _c_list;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _c_size;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _c_index;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	ContactsContact* c;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gpointer _tmp10_;
	ContactsContact* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	gulong id1;
	gulong id2;
	gulong id3;
	gulong _tmp14_;
	gulong _tmp15_;
	gulong _tmp16_;
	gulong _tmp17_;
	gulong _tmp18_;
	gulong _tmp19_;
	ContactsContact* _tmp20_;
	ContactsContact* _tmp21_;
};

struct _ContactsStoreCheckCallCapabilitiesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactsStore* self;
	TpAccountManager* account_manager;
	TpAccountManager* _tmp0_;
	GList* _tmp1_;
	GList* account_collection;
	GList* account_it;
	TpAccount* _tmp2_;
	TpAccount* account;
	TpAccount* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GError * _inner_error_;
};

struct _ContactsStoreCheckAccountCapsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactsStore* self;
	TpAccount* account;
	GQuark addressing;
	GQuark _tmp0_;
	GQuark* features;
	GQuark _tmp1_;
	GQuark* _tmp2_;
	gint features_length1;
	gint _features_size_;
	GQuark* _tmp3_;
	gint _tmp3__length1;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GQuark _tmp6_;
	gboolean _tmp7_;
	GError * _inner_error_;
};


static gpointer contacts_store_parent_class = NULL;

GType contacts_store_get_type (void) G_GNUC_CONST;
GType contacts_contact_get_type (void) G_GNUC_CONST;
#define CONTACTS_STORE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CONTACTS_TYPE_STORE, ContactsStorePrivate))
void contacts_store_refresh (ContactsStore* self);
void contacts_contact_queue_changed (ContactsContact* self);
static gboolean contacts_store_individual_can_replace_at_split (ContactsStore* self,
                                                         FolksIndividual* new_individual);
static gboolean contacts_store_individual_should_replace_at_join (ContactsStore* self,
                                                           FolksIndividual* old_individual);
ContactsContact* contacts_contact_from_individual (FolksIndividual* i);
static void contacts_store_read_dont_suggest_db (ContactsStore* self);
static void contacts_store_write_dont_suggest_db (ContactsStore* self);
gboolean contacts_store_may_suggest_link (ContactsStore* self,
                                          ContactsContact* a,
                                          ContactsContact* b);
void contacts_store_add_no_suggest_link (ContactsStore* self,
                                         ContactsContact* a,
                                         ContactsContact* b);
GeeList* contacts_contact_get_personas_for_display (ContactsContact* self);
static void contacts_store_on_individuals_changed_detailed (ContactsStore* self,
                                                     GeeMultiMap* changes);
static void contacts_store_remove (ContactsStore* self,
                            ContactsContact* c);
static void contacts_store_add (ContactsStore* self,
                         ContactsContact* c);
ContactsContact* contacts_contact_new (ContactsStore* store,
                                       FolksIndividual* i);
ContactsContact* contacts_contact_construct (GType object_type,
                                             ContactsStore* store,
                                             FolksIndividual* i);
void contacts_contact_replace_individual (ContactsContact* self,
                                          FolksIndividual* new_individual);
static void contacts_store_contact_changed_cb (ContactsStore* self,
                                        ContactsContact* c);
static void contacts_store_find_contact_data_free (gpointer _data);
void contacts_store_find_contact (ContactsStore* self,
                                  ContactsStoreContactMatcher matcher,
                                  void* matcher_target,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
ContactsContact* contacts_store_find_contact_finish (ContactsStore* self,
                                                     GAsyncResult* _res_);
static gboolean contacts_store_find_contact_co (ContactsStoreFindContactData* _data_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
gboolean contacts_store_get_is_quiescent (ContactsStore* self);
static gboolean _contacts_store_find_contact_co_gsource_func (gpointer self);
static void __lambda5_ (Block3Data* _data3_,
                 ContactsContact* c);
static void ___lambda5__contacts_store_changed (ContactsStore* _sender,
                                         ContactsContact* c,
                                         gpointer self);
static void __lambda6_ (Block3Data* _data3_,
                 ContactsContact* c);
static void ___lambda6__contacts_store_added (ContactsStore* _sender,
                                       ContactsContact* c,
                                       gpointer self);
static void __lambda7_ (Block3Data* _data3_);
static void ___lambda7__contacts_store_quiescent (ContactsStore* _sender,
                                           gpointer self);
ContactsContact* contacts_store_find_contact_with_persona (ContactsStore* self,
                                                           FolksPersona* persona);
GeeCollection* contacts_store_get_contacts (ContactsStore* self);
static void _contacts_store_contact_changed_cb_contacts_contact_changed (ContactsContact* _sender,
                                                                  gpointer self);
static void contacts_store_check_call_capabilities_data_free (gpointer _data);
static void contacts_store_check_call_capabilities (ContactsStore* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
static void contacts_store_check_call_capabilities_finish (ContactsStore* self,
                                                    GAsyncResult* _res_);
static gboolean contacts_store_check_call_capabilities_co (ContactsStoreCheckCallCapabilitiesData* _data_);
static void contacts_store_check_call_capabilities_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void contacts_store_check_account_caps (ContactsStore* self,
                                        TpAccount* account,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static void contacts_store_check_account_caps_finish (ContactsStore* self,
                                               GAsyncResult* _res_);
static void _contacts_store_check_account_caps_tp_account_manager_account_enabled (TpAccountManager* _sender,
                                                                            TpAccount* account,
                                                                            gpointer self);
static void _contacts_store_check_account_caps_tp_account_manager_account_disabled (TpAccountManager* _sender,
                                                                             TpAccount* account,
                                                                             gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void contacts_store_check_account_caps_data_free (gpointer _data);
static gboolean contacts_store_check_account_caps_co (ContactsStoreCheckAccountCapsData* _data_);
static void contacts_store_check_account_caps_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void contacts_store_set_caller_account (ContactsStore* self,
                                        TpAccount* value);
ContactsStore* contacts_store_new (void);
ContactsStore* contacts_store_construct (GType object_type);
FolksIndividualAggregator* contacts_store_get_aggregator (ContactsStore* self);
static void contacts_store_set_aggregator (ContactsStore* self,
                                    FolksIndividualAggregator* value);
FolksBackendStore* contacts_store_get_backend_store (ContactsStore* self);
TpAccount* contacts_store_get_caller_account (ContactsStore* self);
gboolean contacts_store_get_is_prepared (ContactsStore* self);
static GObject * contacts_store_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _contacts_store___lambda8_ (ContactsStore* self,
                                 FolksBackend* backend);
static void ___lambda9_ (ContactsStore* self);
static void ____lambda9__folks_backend_persona_store_added (FolksBackend* _sender,
                                                     FolksPersonaStore* store,
                                                     gpointer self);
static void ___lambda10_ (ContactsStore* self);
static void ____lambda10__folks_backend_persona_store_removed (FolksBackend* _sender,
                                                        FolksPersonaStore* store,
                                                        gpointer self);
static void __contacts_store___lambda8__folks_backend_store_backend_available (FolksBackendStore* _sender,
                                                                        FolksBackend* backend,
                                                                        gpointer self);
static void _contacts_store___lambda11_ (ContactsStore* self,
                                  GObject* obj,
                                  GParamSpec* pspec);
static gboolean __lambda12_ (ContactsStore* self);
static gboolean ___lambda12__gsource_func (gpointer self);
static void __contacts_store___lambda11__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static void _contacts_store___lambda13_ (ContactsStore* self,
                                  GObject* obj,
                                  GParamSpec* pspec);
static gboolean __lambda14_ (ContactsStore* self);
static gboolean ___lambda14__gsource_func (gpointer self);
static void __contacts_store___lambda13__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static void _contacts_store_on_individuals_changed_detailed_folks_individual_aggregator_individuals_changed_detailed (FolksIndividualAggregator* _sender,
                                                                                                               GeeMultiMap* changes,
                                                                                                               gpointer self);
static void contacts_store_finalize (GObject * obj);
static void _vala_contacts_store_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_contacts_store_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
contacts_store_refresh (ContactsStore* self)
{
	g_return_if_fail (self != NULL);
	{
		GeeArrayList* _c_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _c_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _c_index = 0;
		_tmp0_ = self->priv->contacts;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_c_list = _tmp1_;
		_tmp2_ = _c_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_c_size = _tmp4_;
		_c_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ContactsContact* c = NULL;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ContactsContact* _tmp11_;
			_tmp5_ = _c_index;
			_c_index = _tmp5_ + 1;
			_tmp6_ = _c_index;
			_tmp7_ = _c_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _c_list;
			_tmp9_ = _c_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			c = (ContactsContact*) _tmp10_;
			_tmp11_ = c;
			contacts_contact_queue_changed (_tmp11_);
			_g_object_unref0 (c);
		}
		_g_object_unref0 (_c_list);
	}
}


static gboolean
contacts_store_individual_can_replace_at_split (ContactsStore* self,
                                                FolksIndividual* new_individual)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (new_individual != NULL, FALSE);
	{
		GeeIterator* _p_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
		_tmp0_ = folks_individual_get_personas (new_individual);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_p_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			FolksPersona* p = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			FolksPersona* _tmp6_;
			gconstpointer _tmp7_;
			_tmp3_ = _p_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _p_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			p = (FolksPersona*) _tmp5_;
			_tmp6_ = p;
			_tmp7_ = g_object_get_data ((GObject*) _tmp6_, "contacts-new-contact");
			if ((gboolean) ((gintptr) _tmp7_)) {
				result = FALSE;
				_g_object_unref0 (p);
				_g_object_unref0 (_p_it);
				return result;
			}
			_g_object_unref0 (p);
		}
		_g_object_unref0 (_p_it);
	}
	result = TRUE;
	return result;
}


static gboolean
contacts_store_individual_should_replace_at_join (ContactsStore* self,
                                                  FolksIndividual* old_individual)
{
	gboolean result = FALSE;
	ContactsContact* c = NULL;
	ContactsContact* _tmp0_;
	gconstpointer _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (old_individual != NULL, FALSE);
	_tmp0_ = contacts_contact_from_individual (old_individual);
	c = _tmp0_;
	_tmp1_ = g_object_get_data ((GObject*) c, "contacts-master-at-join");
	result = (gboolean) ((gintptr) _tmp1_);
	_g_object_unref0 (c);
	return result;
}


static void
contacts_store_read_dont_suggest_db (ContactsStore* self)
{
	GeeHashMultiMap* _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->dont_suggest_link;
	gee_multi_map_clear ((GeeMultiMap*) _tmp0_);
	{
		gchar* path = NULL;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* contents = NULL;
		gboolean _tmp3_ = FALSE;
		gchar* _tmp4_ = NULL;
		gboolean _tmp5_;
		_tmp1_ = g_get_user_config_dir ();
		_tmp2_ = g_build_filename (_tmp1_, "gnome-contacts", "dont_suggest.db", NULL);
		path = _tmp2_;
		_tmp5_ = g_file_get_contents (path, &_tmp4_, NULL, &_inner_error_);
		_g_free0 (contents);
		contents = _tmp4_;
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (contents);
			_g_free0 (path);
			goto __catch10_g_error;
		}
		if (_tmp3_) {
			gchar** rows = NULL;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint rows_length1;
			gint _rows_size_;
			gchar** _tmp8_;
			gint _tmp8__length1;
			_tmp7_ = _tmp6_ = g_strsplit (contents, "\n", 0);
			rows = _tmp7_;
			rows_length1 = _vala_array_length (_tmp6_);
			_rows_size_ = rows_length1;
			_tmp8_ = rows;
			_tmp8__length1 = rows_length1;
			{
				gchar** r_collection = NULL;
				gint r_collection_length1 = 0;
				gint _r_collection_size_ = 0;
				gint r_it = 0;
				r_collection = _tmp8_;
				r_collection_length1 = _tmp8__length1;
				for (r_it = 0; r_it < _tmp8__length1; r_it = r_it + 1) {
					gchar* _tmp9_;
					gchar* r = NULL;
					_tmp9_ = g_strdup (r_collection[r_it]);
					r = _tmp9_;
					{
						gchar** ids = NULL;
						const gchar* _tmp10_;
						gchar** _tmp11_;
						gchar** _tmp12_;
						gint ids_length1;
						gint _ids_size_;
						gchar** _tmp13_;
						gint _tmp13__length1;
						_tmp10_ = r;
						_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, " ", 0);
						ids = _tmp12_;
						ids_length1 = _vala_array_length (_tmp11_);
						_ids_size_ = ids_length1;
						_tmp13_ = ids;
						_tmp13__length1 = ids_length1;
						if (_tmp13__length1 == 2) {
							GeeHashMultiMap* _tmp14_;
							gchar** _tmp15_;
							gint _tmp15__length1;
							const gchar* _tmp16_;
							gchar** _tmp17_;
							gint _tmp17__length1;
							const gchar* _tmp18_;
							_tmp14_ = self->dont_suggest_link;
							_tmp15_ = ids;
							_tmp15__length1 = ids_length1;
							_tmp16_ = _tmp15_[0];
							_tmp17_ = ids;
							_tmp17__length1 = ids_length1;
							_tmp18_ = _tmp17_[1];
							gee_multi_map_set ((GeeMultiMap*) _tmp14_, _tmp16_, _tmp18_);
						}
						ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (r);
					}
				}
			}
			rows = (_vala_array_free (rows, rows_length1, (GDestroyNotify) g_free), NULL);
		}
		_g_free0 (contents);
		_g_free0 (path);
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp19_ = e;
		if (!g_error_matches (_tmp19_, G_FILE_ERROR, G_FILE_ERROR_NOENT)) {
			GError* _tmp20_;
			const gchar* _tmp21_;
			_tmp20_ = e;
			_tmp21_ = _tmp20_->message;
			g_warning ("contacts-store.vala:84: error loading no suggestion db: %s\n", _tmp21_);
		}
		_g_error_free0 (e);
	}
	__finally10:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void
contacts_store_write_dont_suggest_db (ContactsStore* self)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gchar* dir = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* path = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		GString* s = NULL;
		GString* _tmp5_;
		const gchar* _tmp26_;
		GString* _tmp27_;
		const gchar* _tmp28_;
		GString* _tmp29_;
		gssize _tmp30_;
		_tmp0_ = g_get_user_config_dir ();
		_tmp1_ = g_build_filename (_tmp0_, "gnome-contacts", NULL);
		dir = _tmp1_;
		_tmp2_ = dir;
		g_mkdir_with_parents (_tmp2_, 0700);
		_tmp3_ = dir;
		_tmp4_ = g_build_filename (_tmp3_, "dont_suggest.db", NULL);
		path = _tmp4_;
		_tmp5_ = g_string_new ("");
		s = _tmp5_;
		{
			GeeIterator* _key_it = NULL;
			GeeHashMultiMap* _tmp6_;
			GeeSet* _tmp7_;
			GeeSet* _tmp8_;
			GeeIterator* _tmp9_;
			GeeIterator* _tmp10_;
			_tmp6_ = self->dont_suggest_link;
			_tmp7_ = gee_multi_map_get_keys ((GeeMultiMap*) _tmp6_);
			_tmp8_ = _tmp7_;
			_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
			_tmp10_ = _tmp9_;
			_g_object_unref0 (_tmp8_);
			_key_it = _tmp10_;
			while (TRUE) {
				GeeIterator* _tmp11_;
				gchar* key = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				_tmp11_ = _key_it;
				if (!gee_iterator_next (_tmp11_)) {
					break;
				}
				_tmp12_ = _key_it;
				_tmp13_ = gee_iterator_get (_tmp12_);
				key = (gchar*) _tmp13_;
				{
					GeeIterator* _value_it = NULL;
					GeeHashMultiMap* _tmp14_;
					const gchar* _tmp15_;
					GeeCollection* _tmp16_;
					GeeCollection* _tmp17_;
					GeeIterator* _tmp18_;
					GeeIterator* _tmp19_;
					_tmp14_ = self->dont_suggest_link;
					_tmp15_ = key;
					_tmp16_ = gee_multi_map_get ((GeeMultiMap*) _tmp14_, _tmp15_);
					_tmp17_ = _tmp16_;
					_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
					_tmp19_ = _tmp18_;
					_g_object_unref0 (_tmp17_);
					_value_it = _tmp19_;
					while (TRUE) {
						GeeIterator* _tmp20_;
						gchar* value = NULL;
						GeeIterator* _tmp21_;
						gpointer _tmp22_;
						GString* _tmp23_;
						const gchar* _tmp24_;
						const gchar* _tmp25_;
						_tmp20_ = _value_it;
						if (!gee_iterator_next (_tmp20_)) {
							break;
						}
						_tmp21_ = _value_it;
						_tmp22_ = gee_iterator_get (_tmp21_);
						value = (gchar*) _tmp22_;
						_tmp23_ = s;
						_tmp24_ = key;
						_tmp25_ = value;
						g_string_append_printf (_tmp23_, "%s %s\n", _tmp24_, _tmp25_);
						_g_free0 (value);
					}
					_g_object_unref0 (_value_it);
				}
				_g_free0 (key);
			}
			_g_object_unref0 (_key_it);
		}
		_tmp26_ = path;
		_tmp27_ = s;
		_tmp28_ = _tmp27_->str;
		_tmp29_ = s;
		_tmp30_ = _tmp29_->len;
		g_file_set_contents (_tmp26_, _tmp28_, _tmp30_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_string_free0 (s);
			_g_free0 (path);
			_g_free0 (dir);
			goto __catch11_g_error;
		}
		_g_string_free0 (s);
		_g_free0 (path);
		_g_free0 (dir);
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp31_ = e;
		_tmp32_ = _tmp31_->message;
		g_warning ("contacts-store.vala:102: error writing no suggestion db: %s\n", _tmp32_);
		_g_error_free0 (e);
	}
	__finally11:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


gboolean
contacts_store_may_suggest_link (ContactsStore* self,
                                 ContactsContact* a,
                                 ContactsContact* b)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (a != NULL, FALSE);
	g_return_val_if_fail (b != NULL, FALSE);
	{
		GeeIterator* _a_persona_it = NULL;
		FolksIndividual* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		_tmp0_ = a->individual;
		_tmp1_ = folks_individual_get_personas (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_a_persona_it = _tmp3_;
		while (TRUE) {
			GeeIterator* _tmp4_;
			FolksPersona* a_persona = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			_tmp4_ = _a_persona_it;
			if (!gee_iterator_next (_tmp4_)) {
				break;
			}
			_tmp5_ = _a_persona_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			a_persona = (FolksPersona*) _tmp6_;
			{
				GeeIterator* _no_link_uid_it = NULL;
				GeeHashMultiMap* _tmp7_;
				FolksPersona* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				GeeCollection* _tmp11_;
				GeeCollection* _tmp12_;
				GeeIterator* _tmp13_;
				GeeIterator* _tmp14_;
				_tmp7_ = self->dont_suggest_link;
				_tmp8_ = a_persona;
				_tmp9_ = folks_persona_get_uid (_tmp8_);
				_tmp10_ = _tmp9_;
				_tmp11_ = gee_multi_map_get ((GeeMultiMap*) _tmp7_, _tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
				_tmp14_ = _tmp13_;
				_g_object_unref0 (_tmp12_);
				_no_link_uid_it = _tmp14_;
				while (TRUE) {
					GeeIterator* _tmp15_;
					gchar* no_link_uid = NULL;
					GeeIterator* _tmp16_;
					gpointer _tmp17_;
					_tmp15_ = _no_link_uid_it;
					if (!gee_iterator_next (_tmp15_)) {
						break;
					}
					_tmp16_ = _no_link_uid_it;
					_tmp17_ = gee_iterator_get (_tmp16_);
					no_link_uid = (gchar*) _tmp17_;
					{
						GeeIterator* _b_persona_it = NULL;
						FolksIndividual* _tmp18_;
						GeeSet* _tmp19_;
						GeeSet* _tmp20_;
						GeeIterator* _tmp21_;
						_tmp18_ = b->individual;
						_tmp19_ = folks_individual_get_personas (_tmp18_);
						_tmp20_ = _tmp19_;
						_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
						_b_persona_it = _tmp21_;
						while (TRUE) {
							GeeIterator* _tmp22_;
							FolksPersona* b_persona = NULL;
							GeeIterator* _tmp23_;
							gpointer _tmp24_;
							FolksPersona* _tmp25_;
							const gchar* _tmp26_;
							const gchar* _tmp27_;
							const gchar* _tmp28_;
							_tmp22_ = _b_persona_it;
							if (!gee_iterator_next (_tmp22_)) {
								break;
							}
							_tmp23_ = _b_persona_it;
							_tmp24_ = gee_iterator_get (_tmp23_);
							b_persona = (FolksPersona*) _tmp24_;
							_tmp25_ = b_persona;
							_tmp26_ = folks_persona_get_uid (_tmp25_);
							_tmp27_ = _tmp26_;
							_tmp28_ = no_link_uid;
							if (g_strcmp0 (_tmp27_, _tmp28_) == 0) {
								result = FALSE;
								_g_object_unref0 (b_persona);
								_g_object_unref0 (_b_persona_it);
								_g_free0 (no_link_uid);
								_g_object_unref0 (_no_link_uid_it);
								_g_object_unref0 (a_persona);
								_g_object_unref0 (_a_persona_it);
								return result;
							}
							_g_object_unref0 (b_persona);
						}
						_g_object_unref0 (_b_persona_it);
					}
					_g_free0 (no_link_uid);
				}
				_g_object_unref0 (_no_link_uid_it);
			}
			_g_object_unref0 (a_persona);
		}
		_g_object_unref0 (_a_persona_it);
	}
	{
		GeeIterator* _b_persona_it = NULL;
		FolksIndividual* _tmp29_;
		GeeSet* _tmp30_;
		GeeSet* _tmp31_;
		GeeIterator* _tmp32_;
		_tmp29_ = b->individual;
		_tmp30_ = folks_individual_get_personas (_tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = gee_iterable_iterator ((GeeIterable*) _tmp31_);
		_b_persona_it = _tmp32_;
		while (TRUE) {
			GeeIterator* _tmp33_;
			FolksPersona* b_persona = NULL;
			GeeIterator* _tmp34_;
			gpointer _tmp35_;
			_tmp33_ = _b_persona_it;
			if (!gee_iterator_next (_tmp33_)) {
				break;
			}
			_tmp34_ = _b_persona_it;
			_tmp35_ = gee_iterator_get (_tmp34_);
			b_persona = (FolksPersona*) _tmp35_;
			{
				GeeIterator* _no_link_uid_it = NULL;
				GeeHashMultiMap* _tmp36_;
				FolksPersona* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				GeeCollection* _tmp40_;
				GeeCollection* _tmp41_;
				GeeIterator* _tmp42_;
				GeeIterator* _tmp43_;
				_tmp36_ = self->dont_suggest_link;
				_tmp37_ = b_persona;
				_tmp38_ = folks_persona_get_uid (_tmp37_);
				_tmp39_ = _tmp38_;
				_tmp40_ = gee_multi_map_get ((GeeMultiMap*) _tmp36_, _tmp39_);
				_tmp41_ = _tmp40_;
				_tmp42_ = gee_iterable_iterator ((GeeIterable*) _tmp41_);
				_tmp43_ = _tmp42_;
				_g_object_unref0 (_tmp41_);
				_no_link_uid_it = _tmp43_;
				while (TRUE) {
					GeeIterator* _tmp44_;
					gchar* no_link_uid = NULL;
					GeeIterator* _tmp45_;
					gpointer _tmp46_;
					_tmp44_ = _no_link_uid_it;
					if (!gee_iterator_next (_tmp44_)) {
						break;
					}
					_tmp45_ = _no_link_uid_it;
					_tmp46_ = gee_iterator_get (_tmp45_);
					no_link_uid = (gchar*) _tmp46_;
					{
						GeeIterator* _a_persona_it = NULL;
						FolksIndividual* _tmp47_;
						GeeSet* _tmp48_;
						GeeSet* _tmp49_;
						GeeIterator* _tmp50_;
						_tmp47_ = a->individual;
						_tmp48_ = folks_individual_get_personas (_tmp47_);
						_tmp49_ = _tmp48_;
						_tmp50_ = gee_iterable_iterator ((GeeIterable*) _tmp49_);
						_a_persona_it = _tmp50_;
						while (TRUE) {
							GeeIterator* _tmp51_;
							FolksPersona* a_persona = NULL;
							GeeIterator* _tmp52_;
							gpointer _tmp53_;
							FolksPersona* _tmp54_;
							const gchar* _tmp55_;
							const gchar* _tmp56_;
							const gchar* _tmp57_;
							_tmp51_ = _a_persona_it;
							if (!gee_iterator_next (_tmp51_)) {
								break;
							}
							_tmp52_ = _a_persona_it;
							_tmp53_ = gee_iterator_get (_tmp52_);
							a_persona = (FolksPersona*) _tmp53_;
							_tmp54_ = a_persona;
							_tmp55_ = folks_persona_get_uid (_tmp54_);
							_tmp56_ = _tmp55_;
							_tmp57_ = no_link_uid;
							if (g_strcmp0 (_tmp56_, _tmp57_) == 0) {
								result = FALSE;
								_g_object_unref0 (a_persona);
								_g_object_unref0 (_a_persona_it);
								_g_free0 (no_link_uid);
								_g_object_unref0 (_no_link_uid_it);
								_g_object_unref0 (b_persona);
								_g_object_unref0 (_b_persona_it);
								return result;
							}
							_g_object_unref0 (a_persona);
						}
						_g_object_unref0 (_a_persona_it);
					}
					_g_free0 (no_link_uid);
				}
				_g_object_unref0 (_no_link_uid_it);
			}
			_g_object_unref0 (b_persona);
		}
		_g_object_unref0 (_b_persona_it);
	}
	result = TRUE;
	return result;
}


void
contacts_store_add_no_suggest_link (ContactsStore* self,
                                    ContactsContact* a,
                                    ContactsContact* b)
{
	FolksPersona* persona1 = NULL;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	gint _tmp2_;
	gpointer* _tmp3_;
	FolksPersona** _tmp4_;
	gint _tmp4__length1;
	FolksPersona* _tmp5_;
	FolksPersona* _tmp6_;
	FolksPersona* _tmp7_;
	FolksPersona* persona2 = NULL;
	GeeList* _tmp8_;
	GeeList* _tmp9_;
	gint _tmp10_;
	gpointer* _tmp11_;
	FolksPersona** _tmp12_;
	gint _tmp12__length1;
	FolksPersona* _tmp13_;
	FolksPersona* _tmp14_;
	FolksPersona* _tmp15_;
	GeeHashMultiMap* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (a != NULL);
	g_return_if_fail (b != NULL);
	_tmp0_ = contacts_contact_get_personas_for_display (a);
	_tmp1_ = _tmp0_;
	_tmp3_ = gee_collection_to_array ((GeeCollection*) _tmp1_, &_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp2_;
	_tmp5_ = _tmp4_[0];
	_tmp6_ = _g_object_ref0 (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (_tmp1_);
	persona1 = _tmp7_;
	_tmp8_ = contacts_contact_get_personas_for_display (b);
	_tmp9_ = _tmp8_;
	_tmp11_ = gee_collection_to_array ((GeeCollection*) _tmp9_, &_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp12__length1 = _tmp10_;
	_tmp13_ = _tmp12_[0];
	_tmp14_ = _g_object_ref0 (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (_tmp9_);
	persona2 = _tmp15_;
	_tmp16_ = self->dont_suggest_link;
	_tmp17_ = folks_persona_get_uid (persona1);
	_tmp18_ = _tmp17_;
	_tmp19_ = folks_persona_get_uid (persona2);
	_tmp20_ = _tmp19_;
	gee_multi_map_set ((GeeMultiMap*) _tmp16_, _tmp18_, _tmp20_);
	contacts_store_write_dont_suggest_db (self);
	_g_object_unref0 (persona2);
	_g_object_unref0 (persona1);
}


static void
contacts_store_on_individuals_changed_detailed (ContactsStore* self,
                                                GeeMultiMap* changes)
{
	GeeHashMap* replaced_individuals = NULL;
	GeeHashMap* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (changes != NULL);
	_tmp0_ = gee_hash_map_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	replaced_individuals = _tmp0_;
	{
		GeeIterator* _old_individual_it = NULL;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp1_ = gee_multi_map_get_keys (changes);
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_old_individual_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			FolksIndividual* old_individual = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			FolksIndividual* _tmp8_;
			_tmp5_ = _old_individual_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _old_individual_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			old_individual = (FolksIndividual*) _tmp7_;
			_tmp8_ = old_individual;
			if (_tmp8_ == NULL) {
				_g_object_unref0 (old_individual);
				continue;
			}
			{
				GeeIterator* _new_individual_it = NULL;
				FolksIndividual* _tmp9_;
				GeeCollection* _tmp10_;
				GeeCollection* _tmp11_;
				GeeIterator* _tmp12_;
				GeeIterator* _tmp13_;
				_tmp9_ = old_individual;
				_tmp10_ = gee_multi_map_get (changes, _tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
				_tmp13_ = _tmp12_;
				_g_object_unref0 (_tmp11_);
				_new_individual_it = _tmp13_;
				while (TRUE) {
					GeeIterator* _tmp14_;
					FolksIndividual* new_individual = NULL;
					GeeIterator* _tmp15_;
					gpointer _tmp16_;
					FolksIndividual* _tmp17_;
					gboolean _tmp18_ = FALSE;
					GeeHashMap* _tmp19_;
					FolksIndividual* _tmp20_;
					_tmp14_ = _new_individual_it;
					if (!gee_iterator_next (_tmp14_)) {
						break;
					}
					_tmp15_ = _new_individual_it;
					_tmp16_ = gee_iterator_get (_tmp15_);
					new_individual = (FolksIndividual*) _tmp16_;
					_tmp17_ = new_individual;
					if (_tmp17_ == NULL) {
						_g_object_unref0 (new_individual);
						continue;
					}
					_tmp19_ = replaced_individuals;
					_tmp20_ = new_individual;
					if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp19_, _tmp20_)) {
						_tmp18_ = TRUE;
					} else {
						FolksIndividual* _tmp21_;
						_tmp21_ = old_individual;
						_tmp18_ = contacts_store_individual_should_replace_at_join (self, _tmp21_);
					}
					if (_tmp18_) {
						GeeHashMap* _tmp22_;
						FolksIndividual* _tmp23_;
						FolksIndividual* _tmp24_;
						_tmp22_ = replaced_individuals;
						_tmp23_ = new_individual;
						_tmp24_ = old_individual;
						gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, _tmp23_, _tmp24_);
					}
					_g_object_unref0 (new_individual);
				}
				_g_object_unref0 (_new_individual_it);
			}
			_g_object_unref0 (old_individual);
		}
		_g_object_unref0 (_old_individual_it);
	}
	{
		GeeIterator* _old_individual_it = NULL;
		GeeSet* _tmp25_;
		GeeSet* _tmp26_;
		GeeIterator* _tmp27_;
		GeeIterator* _tmp28_;
		_tmp25_ = gee_multi_map_get_keys (changes);
		_tmp26_ = _tmp25_;
		_tmp27_ = gee_iterable_iterator ((GeeIterable*) _tmp26_);
		_tmp28_ = _tmp27_;
		_g_object_unref0 (_tmp26_);
		_old_individual_it = _tmp28_;
		while (TRUE) {
			GeeIterator* _tmp29_;
			FolksIndividual* old_individual = NULL;
			GeeIterator* _tmp30_;
			gpointer _tmp31_;
			GeeHashSet* replacements = NULL;
			GeeHashSet* _tmp61_;
			_tmp29_ = _old_individual_it;
			if (!gee_iterator_next (_tmp29_)) {
				break;
			}
			_tmp30_ = _old_individual_it;
			_tmp31_ = gee_iterator_get (_tmp30_);
			old_individual = (FolksIndividual*) _tmp31_;
			replacements = NULL;
			{
				GeeIterator* _new_individual_it = NULL;
				FolksIndividual* _tmp32_;
				GeeCollection* _tmp33_;
				GeeCollection* _tmp34_;
				GeeIterator* _tmp35_;
				GeeIterator* _tmp36_;
				_tmp32_ = old_individual;
				_tmp33_ = gee_multi_map_get (changes, _tmp32_);
				_tmp34_ = _tmp33_;
				_tmp35_ = gee_iterable_iterator ((GeeIterable*) _tmp34_);
				_tmp36_ = _tmp35_;
				_g_object_unref0 (_tmp34_);
				_new_individual_it = _tmp36_;
				while (TRUE) {
					GeeIterator* _tmp37_;
					FolksIndividual* new_individual = NULL;
					GeeIterator* _tmp38_;
					gpointer _tmp39_;
					gboolean _tmp40_ = FALSE;
					gboolean _tmp41_ = FALSE;
					FolksIndividual* _tmp42_;
					_tmp37_ = _new_individual_it;
					if (!gee_iterator_next (_tmp37_)) {
						break;
					}
					_tmp38_ = _new_individual_it;
					_tmp39_ = gee_iterator_get (_tmp38_);
					new_individual = (FolksIndividual*) _tmp39_;
					_tmp42_ = old_individual;
					if (_tmp42_ != NULL) {
						FolksIndividual* _tmp43_;
						_tmp43_ = new_individual;
						_tmp41_ = _tmp43_ != NULL;
					} else {
						_tmp41_ = FALSE;
					}
					if (_tmp41_) {
						GeeHashMap* _tmp44_;
						FolksIndividual* _tmp45_;
						gpointer _tmp46_;
						FolksIndividual* _tmp47_;
						FolksIndividual* _tmp48_;
						_tmp44_ = replaced_individuals;
						_tmp45_ = new_individual;
						_tmp46_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp44_, _tmp45_);
						_tmp47_ = (FolksIndividual*) _tmp46_;
						_tmp48_ = old_individual;
						_tmp40_ = _tmp47_ == _tmp48_;
						_g_object_unref0 (_tmp47_);
					} else {
						_tmp40_ = FALSE;
					}
					if (_tmp40_) {
						GeeHashSet* _tmp49_;
						GeeHashSet* _tmp51_;
						FolksIndividual* _tmp52_;
						_tmp49_ = replacements;
						if (_tmp49_ == NULL) {
							GeeHashSet* _tmp50_;
							_tmp50_ = gee_hash_set_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
							_g_object_unref0 (replacements);
							replacements = _tmp50_;
						}
						_tmp51_ = replacements;
						_tmp52_ = new_individual;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp51_, _tmp52_);
					} else {
						FolksIndividual* _tmp53_;
						_tmp53_ = old_individual;
						if (_tmp53_ != NULL) {
							ContactsContact* c = NULL;
							FolksIndividual* _tmp54_;
							ContactsContact* _tmp55_;
							ContactsContact* _tmp56_;
							_tmp54_ = old_individual;
							_tmp55_ = contacts_contact_from_individual (_tmp54_);
							c = _tmp55_;
							_tmp56_ = c;
							contacts_store_remove (self, _tmp56_);
							_g_object_unref0 (c);
						} else {
							FolksIndividual* _tmp57_;
							_tmp57_ = new_individual;
							if (_tmp57_ != NULL) {
								FolksIndividual* _tmp58_;
								ContactsContact* _tmp59_;
								ContactsContact* _tmp60_;
								_tmp58_ = new_individual;
								_tmp59_ = contacts_contact_new (self, _tmp58_);
								_tmp60_ = _tmp59_;
								contacts_store_add (self, _tmp60_);
								_g_object_unref0 (_tmp60_);
							}
						}
					}
					_g_object_unref0 (new_individual);
				}
				_g_object_unref0 (_new_individual_it);
			}
			_tmp61_ = replacements;
			if (_tmp61_ != NULL) {
				FolksIndividual* main_individual = NULL;
				ContactsContact* c = NULL;
				FolksIndividual* _tmp70_;
				ContactsContact* _tmp71_;
				ContactsContact* _tmp72_;
				FolksIndividual* _tmp73_;
				main_individual = NULL;
				{
					GeeIterator* _i_it = NULL;
					GeeHashSet* _tmp62_;
					GeeIterator* _tmp63_;
					_tmp62_ = replacements;
					_tmp63_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp62_);
					_i_it = _tmp63_;
					while (TRUE) {
						GeeIterator* _tmp64_;
						FolksIndividual* i = NULL;
						GeeIterator* _tmp65_;
						gpointer _tmp66_;
						FolksIndividual* _tmp67_;
						FolksIndividual* _tmp68_;
						FolksIndividual* _tmp69_;
						_tmp64_ = _i_it;
						if (!gee_iterator_next (_tmp64_)) {
							break;
						}
						_tmp65_ = _i_it;
						_tmp66_ = gee_iterator_get (_tmp65_);
						i = (FolksIndividual*) _tmp66_;
						_tmp67_ = i;
						_tmp68_ = _g_object_ref0 (_tmp67_);
						_g_object_unref0 (main_individual);
						main_individual = _tmp68_;
						_tmp69_ = i;
						if (contacts_store_individual_can_replace_at_split (self, _tmp69_)) {
							_g_object_unref0 (i);
							break;
						}
						_g_object_unref0 (i);
					}
					_g_object_unref0 (_i_it);
				}
				_tmp70_ = old_individual;
				_tmp71_ = contacts_contact_from_individual (_tmp70_);
				c = _tmp71_;
				_tmp72_ = c;
				_tmp73_ = main_individual;
				contacts_contact_replace_individual (_tmp72_, _tmp73_);
				{
					GeeIterator* _i_it = NULL;
					GeeHashSet* _tmp74_;
					GeeIterator* _tmp75_;
					_tmp74_ = replacements;
					_tmp75_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp74_);
					_i_it = _tmp75_;
					while (TRUE) {
						GeeIterator* _tmp76_;
						FolksIndividual* i = NULL;
						GeeIterator* _tmp77_;
						gpointer _tmp78_;
						FolksIndividual* _tmp79_;
						FolksIndividual* _tmp80_;
						_tmp76_ = _i_it;
						if (!gee_iterator_next (_tmp76_)) {
							break;
						}
						_tmp77_ = _i_it;
						_tmp78_ = gee_iterator_get (_tmp77_);
						i = (FolksIndividual*) _tmp78_;
						_tmp79_ = i;
						_tmp80_ = main_individual;
						if (_tmp79_ != _tmp80_) {
							FolksIndividual* _tmp81_;
							ContactsContact* _tmp82_;
							ContactsContact* _tmp83_;
							_tmp81_ = i;
							_tmp82_ = contacts_contact_new (self, _tmp81_);
							_tmp83_ = _tmp82_;
							contacts_store_add (self, _tmp83_);
							_g_object_unref0 (_tmp83_);
						}
						_g_object_unref0 (i);
					}
					_g_object_unref0 (_i_it);
				}
				_g_object_unref0 (c);
				_g_object_unref0 (main_individual);
			}
			_g_object_unref0 (replacements);
			_g_object_unref0 (old_individual);
		}
		_g_object_unref0 (_old_individual_it);
	}
	_g_object_unref0 (replaced_individuals);
}


static void
contacts_store_contact_changed_cb (ContactsStore* self,
                                   ContactsContact* c)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_CHANGED_SIGNAL], 0, c);
}


static void
contacts_store_find_contact_data_free (gpointer _data)
{
	ContactsStoreFindContactData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (ContactsStoreFindContactData, _data_);
}


void
contacts_store_find_contact (ContactsStore* self,
                             ContactsStoreContactMatcher matcher,
                             void* matcher_target,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	ContactsStoreFindContactData* _data_;
	ContactsStore* _tmp0_;
	_data_ = g_slice_new0 (ContactsStoreFindContactData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, contacts_store_find_contact_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_data_->matcher = matcher;
	_data_->matcher_target = matcher_target;
	contacts_store_find_contact_co (_data_);
}


ContactsContact*
contacts_store_find_contact_finish (ContactsStore* self,
                                    GAsyncResult* _res_)
{
	ContactsContact* result;
	ContactsStoreFindContactData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}


static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		ContactsStore* self;
		self = _data3_->self;
		(_data3_->callback_target_destroy_notify == NULL) ? NULL : (_data3_->callback_target_destroy_notify (_data3_->callback_target), NULL);
		_data3_->callback = NULL;
		_data3_->callback_target = NULL;
		_data3_->callback_target_destroy_notify = NULL;
		_g_object_unref0 (_data3_->matched);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}


static gboolean
_contacts_store_find_contact_co_gsource_func (gpointer self)
{
	gboolean result;
	result = contacts_store_find_contact_co (self);
	return result;
}


static void
__lambda5_ (Block3Data* _data3_,
            ContactsContact* c)
{
	ContactsStore* self;
	self = _data3_->self;
	g_return_if_fail (c != NULL);
	if (_data3_->matcher (c, _data3_->matcher_target)) {
		ContactsContact* _tmp0_;
		GSourceFunc _tmp1_;
		void* _tmp1__target;
		_tmp0_ = _g_object_ref0 (c);
		_g_object_unref0 (_data3_->matched);
		_data3_->matched = _tmp0_;
		_tmp1_ = _data3_->callback;
		_tmp1__target = _data3_->callback_target;
		_tmp1_ (_tmp1__target);
	}
}


static void
___lambda5__contacts_store_changed (ContactsStore* _sender,
                                    ContactsContact* c,
                                    gpointer self)
{
	__lambda5_ (self, c);
}


static void
__lambda6_ (Block3Data* _data3_,
            ContactsContact* c)
{
	ContactsStore* self;
	self = _data3_->self;
	g_return_if_fail (c != NULL);
	if (_data3_->matcher (c, _data3_->matcher_target)) {
		ContactsContact* _tmp0_;
		GSourceFunc _tmp1_;
		void* _tmp1__target;
		_tmp0_ = _g_object_ref0 (c);
		_g_object_unref0 (_data3_->matched);
		_data3_->matched = _tmp0_;
		_tmp1_ = _data3_->callback;
		_tmp1__target = _data3_->callback_target;
		_tmp1_ (_tmp1__target);
	}
}


static void
___lambda6__contacts_store_added (ContactsStore* _sender,
                                  ContactsContact* c,
                                  gpointer self)
{
	__lambda6_ (self, c);
}


static void
__lambda7_ (Block3Data* _data3_)
{
	ContactsStore* self;
	GSourceFunc _tmp0_;
	void* _tmp0__target;
	self = _data3_->self;
	_tmp0_ = _data3_->callback;
	_tmp0__target = _data3_->callback_target;
	_tmp0_ (_tmp0__target);
}


static void
___lambda7__contacts_store_quiescent (ContactsStore* _sender,
                                      gpointer self)
{
	__lambda7_ (self);
}


static gboolean
contacts_store_find_contact_co (ContactsStoreFindContactData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data3_ = g_slice_new0 (Block3Data);
	_data_->_data3_->_ref_count_ = 1;
	_data_->_data3_->self = g_object_ref (_data_->self);
	_data_->_data3_->matcher = _data_->matcher;
	_data_->_data3_->matcher_target = _data_->matcher_target;
	_data_->_data3_->_async_data_ = _data_;
	{
		_data_->_tmp0_ = _data_->self->priv->contacts;
		_data_->_tmp1_ = _g_object_ref0 (_data_->_tmp0_);
		_data_->_c_list = _data_->_tmp1_;
		_data_->_tmp2_ = _data_->_c_list;
		_data_->_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp2_);
		_data_->_tmp4_ = _data_->_tmp3_;
		_data_->_c_size = _data_->_tmp4_;
		_data_->_c_index = -1;
		while (TRUE) {
			_data_->_tmp5_ = _data_->_c_index;
			_data_->_c_index = _data_->_tmp5_ + 1;
			_data_->_tmp6_ = _data_->_c_index;
			_data_->_tmp7_ = _data_->_c_size;
			if (!(_data_->_tmp6_ < _data_->_tmp7_)) {
				break;
			}
			_data_->_tmp8_ = _data_->_c_list;
			_data_->_tmp9_ = _data_->_c_index;
			_data_->_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp8_, _data_->_tmp9_);
			_data_->c = (ContactsContact*) _data_->_tmp10_;
			_data_->_tmp11_ = _data_->c;
			if (_data_->_data3_->matcher (_data_->_tmp11_, _data_->_data3_->matcher_target)) {
				_data_->result = _data_->c;
				_g_object_unref0 (_data_->_c_list);
				block3_data_unref (_data_->_data3_);
				_data_->_data3_ = NULL;
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
				if (_data_->_state_ != 0) {
					while (g_task_get_completed (_data_->_async_result) != TRUE) {
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
					}
				}
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
			_g_object_unref0 (_data_->c);
		}
		_g_object_unref0 (_data_->_c_list);
	}
	_data_->_tmp12_ = contacts_store_get_is_quiescent (_data_->self);
	_data_->_tmp13_ = _data_->_tmp12_;
	if (_data_->_tmp13_) {
		_data_->result = NULL;
		block3_data_unref (_data_->_data3_);
		_data_->_data3_ = NULL;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (g_task_get_completed (_data_->_async_result) != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_data3_->matched = NULL;
	_data_->_data3_->callback = _contacts_store_find_contact_co_gsource_func;
	_data_->_data3_->callback_target = _data_;
	_data_->_data3_->callback_target_destroy_notify = NULL;
	_data_->_tmp14_ = g_signal_connect_data (_data_->self, "changed", (GCallback) ___lambda5__contacts_store_changed, block3_data_ref (_data_->_data3_), (GClosureNotify) block3_data_unref, 0);
	_data_->id1 = _data_->_tmp14_;
	_data_->_tmp15_ = g_signal_connect_data (_data_->self, "added", (GCallback) ___lambda6__contacts_store_added, block3_data_ref (_data_->_data3_), (GClosureNotify) block3_data_unref, 0);
	_data_->id2 = _data_->_tmp15_;
	_data_->_tmp16_ = g_signal_connect_data (_data_->self, "quiescent", (GCallback) ___lambda7__contacts_store_quiescent, block3_data_ref (_data_->_data3_), (GClosureNotify) block3_data_unref, 0);
	_data_->id3 = _data_->_tmp16_;
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp17_ = _data_->id1;
	g_signal_handler_disconnect ((GObject*) _data_->self, _data_->_tmp17_);
	_data_->_tmp18_ = _data_->id2;
	g_signal_handler_disconnect ((GObject*) _data_->self, _data_->_tmp18_);
	_data_->_tmp19_ = _data_->id3;
	g_signal_handler_disconnect ((GObject*) _data_->self, _data_->_tmp19_);
	_data_->_tmp20_ = _data_->_data3_->matched;
	_data_->_tmp21_ = _g_object_ref0 (_data_->_tmp20_);
	_data_->result = _data_->_tmp21_;
	block3_data_unref (_data_->_data3_);
	_data_->_data3_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


ContactsContact*
contacts_store_find_contact_with_persona (ContactsStore* self,
                                          FolksPersona* persona)
{
	ContactsContact* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (persona != NULL, NULL);
	{
		GeeArrayList* _contact_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _contact_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _contact_index = 0;
		_tmp0_ = self->priv->contacts;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_contact_list = _tmp1_;
		_tmp2_ = _contact_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_contact_size = _tmp4_;
		_contact_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ContactsContact* contact = NULL;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ContactsContact* _tmp11_;
			FolksIndividual* _tmp12_;
			GeeSet* _tmp13_;
			GeeSet* _tmp14_;
			_tmp5_ = _contact_index;
			_contact_index = _tmp5_ + 1;
			_tmp6_ = _contact_index;
			_tmp7_ = _contact_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _contact_list;
			_tmp9_ = _contact_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			contact = (ContactsContact*) _tmp10_;
			_tmp11_ = contact;
			_tmp12_ = _tmp11_->individual;
			_tmp13_ = folks_individual_get_personas (_tmp12_);
			_tmp14_ = _tmp13_;
			if (gee_collection_contains ((GeeCollection*) _tmp14_, persona)) {
				result = contact;
				_g_object_unref0 (_contact_list);
				return result;
			}
			_g_object_unref0 (contact);
		}
		_g_object_unref0 (_contact_list);
	}
	result = NULL;
	return result;
}


GeeCollection*
contacts_store_get_contacts (ContactsStore* self)
{
	GeeCollection* result = NULL;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->contacts;
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = (GeeCollection*) _tmp2_;
	return result;
}


static void
_contacts_store_contact_changed_cb_contacts_contact_changed (ContactsContact* _sender,
                                                             gpointer self)
{
	contacts_store_contact_changed_cb ((ContactsStore*) self, _sender);
}


static void
contacts_store_add (ContactsStore* self,
                    ContactsContact* c)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->contacts;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, c);
	g_signal_connect_object (c, "changed", (GCallback) _contacts_store_contact_changed_cb_contacts_contact_changed, self, 0);
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_ADDED_SIGNAL], 0, c);
}


static void
contacts_store_remove (ContactsStore* self,
                       ContactsContact* c)
{
	guint _tmp0_;
	gint i = 0;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeArrayList* _tmp14_;
	GeeArrayList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gpointer _tmp18_;
	ContactsContact* _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	g_signal_parse_name ("changed", CONTACTS_TYPE_CONTACT, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (c, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _contacts_store_contact_changed_cb_contacts_contact_changed, self);
	_tmp1_ = self->priv->contacts;
	i = gee_abstract_list_index_of ((GeeAbstractList*) _tmp1_, c);
	_tmp2_ = i;
	_tmp3_ = self->priv->contacts;
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp2_ != (_tmp5_ - 1)) {
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		GeeArrayList* _tmp8_;
		GeeArrayList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gpointer _tmp12_;
		ContactsContact* _tmp13_;
		_tmp6_ = self->priv->contacts;
		_tmp7_ = i;
		_tmp8_ = self->priv->contacts;
		_tmp9_ = self->priv->contacts;
		_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp11_ - 1);
		_tmp13_ = (ContactsContact*) _tmp12_;
		gee_abstract_list_set ((GeeAbstractList*) _tmp6_, _tmp7_, _tmp13_);
		_g_object_unref0 (_tmp13_);
	}
	_tmp14_ = self->priv->contacts;
	_tmp15_ = self->priv->contacts;
	_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp14_, _tmp17_ - 1);
	_tmp19_ = (ContactsContact*) _tmp18_;
	_g_object_unref0 (_tmp19_);
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_REMOVED_SIGNAL], 0, c);
}


static void
contacts_store_check_call_capabilities_data_free (gpointer _data)
{
	ContactsStoreCheckCallCapabilitiesData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (ContactsStoreCheckCallCapabilitiesData, _data_);
}


static void
contacts_store_check_call_capabilities (ContactsStore* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	ContactsStoreCheckCallCapabilitiesData* _data_;
	ContactsStore* _tmp0_;
	_data_ = g_slice_new0 (ContactsStoreCheckCallCapabilitiesData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, contacts_store_check_call_capabilities_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	contacts_store_check_call_capabilities_co (_data_);
}


static void
contacts_store_check_call_capabilities_finish (ContactsStore* self,
                                               GAsyncResult* _res_)
{
	ContactsStoreCheckCallCapabilitiesData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static void
contacts_store_check_call_capabilities_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	ContactsStoreCheckCallCapabilitiesData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	contacts_store_check_call_capabilities_co (_data_);
}


static void
_contacts_store_check_account_caps_tp_account_manager_account_enabled (TpAccountManager* _sender,
                                                                       TpAccount* account,
                                                                       gpointer self)
{
	contacts_store_check_account_caps ((ContactsStore*) self, account, NULL, NULL);
}


static void
_contacts_store_check_account_caps_tp_account_manager_account_disabled (TpAccountManager* _sender,
                                                                        TpAccount* account,
                                                                        gpointer self)
{
	contacts_store_check_account_caps ((ContactsStore*) self, account, NULL, NULL);
}


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


static gboolean
contacts_store_check_call_capabilities_co (ContactsStoreCheckCallCapabilitiesData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = tp_account_manager_dup ();
	_data_->account_manager = _data_->_tmp0_;
	{
		_data_->_state_ = 1;
		tp_proxy_prepare_async ((TpProxy*) _data_->account_manager, NULL, contacts_store_check_call_capabilities_ready, _data_);
		return FALSE;
		_state_1:
		tp_proxy_prepare_finish ((TpProxy*) _data_->account_manager, _data_->_res_, &_data_->_inner_error_);
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			goto __catch12_g_error;
		}
		g_signal_connect_object (_data_->account_manager, "account-enabled", (GCallback) _contacts_store_check_account_caps_tp_account_manager_account_enabled, _data_->self, 0);
		g_signal_connect_object (_data_->account_manager, "account-disabled", (GCallback) _contacts_store_check_account_caps_tp_account_manager_account_disabled, _data_->self, 0);
		_data_->_tmp1_ = tp_account_manager_dup_valid_accounts (_data_->account_manager);
		{
			_data_->account_collection = _data_->_tmp1_;
			for (_data_->account_it = _data_->account_collection; _data_->account_it != NULL; _data_->account_it = _data_->account_it->next) {
				_data_->_tmp2_ = _g_object_ref0 ((TpAccount*) _data_->account_it->data);
				_data_->account = _data_->_tmp2_;
				{
					_data_->_tmp3_ = _data_->account;
					_data_->_state_ = 2;
					contacts_store_check_account_caps (_data_->self, _data_->_tmp3_, contacts_store_check_call_capabilities_ready, _data_);
					return FALSE;
					_state_2:
					contacts_store_check_account_caps_finish (_data_->self, _data_->_res_);
					_g_object_unref0 (_data_->account);
				}
			}
			__g_list_free__g_object_unref0_0 (_data_->account_collection);
		}
	}
	goto __finally12;
	__catch12_g_error:
	{
		_data_->e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp4_ = _data_->e;
		_data_->_tmp5_ = _data_->_tmp4_->message;
		g_warning ("contacts-store.vala:324: Unable to check accounts caps %s", _data_->_tmp5_);
		_g_error_free0 (_data_->e);
	}
	__finally12:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		_g_object_unref0 (_data_->account_manager);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_object_unref0 (_data_->account_manager);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void
contacts_store_check_account_caps_data_free (gpointer _data)
{
	ContactsStoreCheckAccountCapsData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_g_object_unref0 (_data_->self);
	g_slice_free (ContactsStoreCheckAccountCapsData, _data_);
}


static void
contacts_store_check_account_caps (ContactsStore* self,
                                   TpAccount* account,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	ContactsStoreCheckAccountCapsData* _data_;
	ContactsStore* _tmp0_;
	TpAccount* _tmp1_;
	_data_ = g_slice_new0 (ContactsStoreCheckAccountCapsData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, contacts_store_check_account_caps_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp1_;
	contacts_store_check_account_caps_co (_data_);
}


static void
contacts_store_check_account_caps_finish (ContactsStore* self,
                                          GAsyncResult* _res_)
{
	ContactsStoreCheckAccountCapsData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static void
contacts_store_check_account_caps_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	ContactsStoreCheckAccountCapsData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	contacts_store_check_account_caps_co (_data_);
}


static gboolean
contacts_store_check_account_caps_co (ContactsStoreCheckAccountCapsData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->addressing = tp_account_get_feature_quark_addressing ();
	_data_->_tmp0_ = _data_->addressing;
	if (!tp_proxy_is_prepared ((TpProxy*) _data_->account, _data_->_tmp0_)) {
		_data_->_tmp1_ = _data_->addressing;
		_data_->_tmp2_ = g_new0 (GQuark, 1);
		_data_->_tmp2_[0] = _data_->_tmp1_;
		_data_->features = _data_->_tmp2_;
		_data_->features_length1 = 1;
		_data_->_features_size_ = _data_->features_length1;
		{
			_data_->_tmp3_ = _data_->features;
			_data_->_tmp3__length1 = _data_->features_length1;
			_data_->_state_ = 1;
			tp_proxy_prepare_async ((TpProxy*) _data_->account, _data_->_tmp3_, contacts_store_check_account_caps_ready, _data_);
			return FALSE;
			_state_1:
			tp_proxy_prepare_finish ((TpProxy*) _data_->account, _data_->_res_, &_data_->_inner_error_);
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
				goto __catch13_g_error;
			}
		}
		goto __finally13;
		__catch13_g_error:
		{
			_data_->e = _data_->_inner_error_;
			_data_->_inner_error_ = NULL;
			_data_->_tmp4_ = _data_->e;
			_data_->_tmp5_ = _data_->_tmp4_->message;
			g_warning ("contacts-store.vala:335: Unable to prepare account %s", _data_->_tmp5_);
			_g_error_free0 (_data_->e);
		}
		__finally13:
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			_data_->features = (g_free (_data_->features), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->features = (g_free (_data_->features), NULL);
	}
	_data_->_tmp6_ = _data_->addressing;
	if (tp_proxy_is_prepared ((TpProxy*) _data_->account, _data_->_tmp6_)) {
		if (tp_account_is_enabled (_data_->account)) {
			_data_->_tmp7_ = tp_account_associated_with_uri_scheme (_data_->account, "tel");
		} else {
			_data_->_tmp7_ = FALSE;
		}
		if (_data_->_tmp7_) {
			contacts_store_set_caller_account (_data_->self, _data_->account);
		}
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


ContactsStore*
contacts_store_construct (GType object_type)
{
	ContactsStore * self = NULL;
	self = (ContactsStore*) g_object_new (object_type, NULL);
	return self;
}


ContactsStore*
contacts_store_new (void)
{
	return contacts_store_construct (CONTACTS_TYPE_STORE);
}


FolksIndividualAggregator*
contacts_store_get_aggregator (ContactsStore* self)
{
	FolksIndividualAggregator* result;
	FolksIndividualAggregator* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_aggregator;
	result = _tmp0_;
	return result;
}


static void
contacts_store_set_aggregator (ContactsStore* self,
                               FolksIndividualAggregator* value)
{
	g_return_if_fail (self != NULL);
	if (contacts_store_get_aggregator (self) != value) {
		FolksIndividualAggregator* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_aggregator);
		self->priv->_aggregator = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, contacts_store_properties[CONTACTS_STORE_AGGREGATOR_PROPERTY]);
	}
}


FolksBackendStore*
contacts_store_get_backend_store (ContactsStore* self)
{
	FolksBackendStore* result;
	FolksIndividualAggregator* _tmp0_;
	FolksBackendStore* _tmp1_;
	FolksBackendStore* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_aggregator;
	_tmp1_ = folks_individual_aggregator_get_backend_store (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


TpAccount*
contacts_store_get_caller_account (ContactsStore* self)
{
	TpAccount* result;
	TpAccount* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_caller_account;
	result = _tmp0_;
	return result;
}


static void
contacts_store_set_caller_account (ContactsStore* self,
                                   TpAccount* value)
{
	g_return_if_fail (self != NULL);
	if (contacts_store_get_caller_account (self) != value) {
		TpAccount* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_caller_account);
		self->priv->_caller_account = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, contacts_store_properties[CONTACTS_STORE_CALLER_ACCOUNT_PROPERTY]);
	}
}


gboolean
contacts_store_get_is_quiescent (ContactsStore* self)
{
	gboolean result;
	FolksIndividualAggregator* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_aggregator;
	_tmp1_ = folks_individual_aggregator_get_is_quiescent (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


gboolean
contacts_store_get_is_prepared (ContactsStore* self)
{
	gboolean result;
	FolksIndividualAggregator* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_aggregator;
	_tmp1_ = folks_individual_aggregator_get_is_prepared (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static void
___lambda9_ (ContactsStore* self)
{
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_EDS_PERSONA_STORE_CHANGED_SIGNAL], 0);
}


static void
____lambda9__folks_backend_persona_store_added (FolksBackend* _sender,
                                                FolksPersonaStore* store,
                                                gpointer self)
{
	___lambda9_ ((ContactsStore*) self);
}


static void
___lambda10_ (ContactsStore* self)
{
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_EDS_PERSONA_STORE_CHANGED_SIGNAL], 0);
}


static void
____lambda10__folks_backend_persona_store_removed (FolksBackend* _sender,
                                                   FolksPersonaStore* store,
                                                   gpointer self)
{
	___lambda10_ ((ContactsStore*) self);
}


static void
_contacts_store___lambda8_ (ContactsStore* self,
                            FolksBackend* backend)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (backend != NULL);
	_tmp0_ = folks_backend_get_name (backend);
	_tmp1_ = _tmp0_;
	if (g_strcmp0 (_tmp1_, "eds") == 0) {
		g_signal_connect_object (backend, "persona-store-added", (GCallback) ____lambda9__folks_backend_persona_store_added, self, 0);
		g_signal_connect_object (backend, "persona-store-removed", (GCallback) ____lambda10__folks_backend_persona_store_removed, self, 0);
	}
}


static void
__contacts_store___lambda8__folks_backend_store_backend_available (FolksBackendStore* _sender,
                                                                   FolksBackend* backend,
                                                                   gpointer self)
{
	_contacts_store___lambda8_ ((ContactsStore*) self, backend);
}


static gboolean
__lambda12_ (ContactsStore* self)
{
	gboolean result = FALSE;
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_QUIESCENT_SIGNAL], 0);
	result = FALSE;
	return result;
}


static gboolean
___lambda12__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda12_ ((ContactsStore*) self);
	return result;
}


static void
_contacts_store___lambda11_ (ContactsStore* self,
                             GObject* obj,
                             GParamSpec* pspec)
{
	g_return_if_fail (obj != NULL);
	g_return_if_fail (pspec != NULL);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda12__gsource_func, g_object_ref (self), g_object_unref);
}


static void
__contacts_store___lambda11__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
	_contacts_store___lambda11_ ((ContactsStore*) self, _sender, pspec);
}


static gboolean
__lambda14_ (ContactsStore* self)
{
	gboolean result = FALSE;
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_PREPARED_SIGNAL], 0);
	result = FALSE;
	return result;
}


static gboolean
___lambda14__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda14_ ((ContactsStore*) self);
	return result;
}


static void
_contacts_store___lambda13_ (ContactsStore* self,
                             GObject* obj,
                             GParamSpec* pspec)
{
	g_return_if_fail (obj != NULL);
	g_return_if_fail (pspec != NULL);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda14__gsource_func, g_object_ref (self), g_object_unref);
}


static void
__contacts_store___lambda13__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
	_contacts_store___lambda13_ ((ContactsStore*) self, _sender, pspec);
}


static void
_contacts_store_on_individuals_changed_detailed_folks_individual_aggregator_individuals_changed_detailed (FolksIndividualAggregator* _sender,
                                                                                                          GeeMultiMap* changes,
                                                                                                          gpointer self)
{
	contacts_store_on_individuals_changed_detailed ((ContactsStore*) self, changes);
}


static GObject *
contacts_store_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ContactsStore * self;
	GeeArrayList* _tmp0_;
	GeeHashMultiMap* _tmp1_;
	FolksBackendStore* backend_store = NULL;
	FolksBackendStore* _tmp2_;
	FolksBackendStore* _tmp3_;
	FolksBackendStore* _tmp4_;
	FolksIndividualAggregator* _tmp5_;
	FolksIndividualAggregator* _tmp6_;
	FolksIndividualAggregator* _tmp7_;
	FolksIndividualAggregator* _tmp8_;
	FolksIndividualAggregator* _tmp9_;
	FolksIndividualAggregator* _tmp10_;
	parent_class = G_OBJECT_CLASS (contacts_store_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_STORE, ContactsStore);
	_tmp0_ = gee_array_list_new (CONTACTS_TYPE_CONTACT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->contacts);
	self->priv->contacts = _tmp0_;
	_tmp1_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->dont_suggest_link);
	self->dont_suggest_link = _tmp1_;
	contacts_store_read_dont_suggest_db (self);
	_tmp2_ = folks_backend_store_dup ();
	backend_store = _tmp2_;
	_tmp3_ = backend_store;
	g_signal_connect_object (_tmp3_, "backend-available", (GCallback) __contacts_store___lambda8__folks_backend_store_backend_available, self, 0);
	_tmp4_ = backend_store;
	_tmp5_ = folks_individual_aggregator_dup_with_backend_store (_tmp4_);
	_tmp6_ = _tmp5_;
	contacts_store_set_aggregator (self, _tmp6_);
	_g_object_unref0 (_tmp6_);
	_tmp7_ = self->priv->_aggregator;
	g_signal_connect_object ((GObject*) _tmp7_, "notify::is-quiescent", (GCallback) __contacts_store___lambda11__g_object_notify, self, 0);
	_tmp8_ = self->priv->_aggregator;
	g_signal_connect_object ((GObject*) _tmp8_, "notify::is-prepared", (GCallback) __contacts_store___lambda13__g_object_notify, self, 0);
	_tmp9_ = self->priv->_aggregator;
	g_signal_connect_object (_tmp9_, "individuals-changed-detailed", (GCallback) _contacts_store_on_individuals_changed_detailed_folks_individual_aggregator_individuals_changed_detailed, self, 0);
	_tmp10_ = self->priv->_aggregator;
	folks_individual_aggregator_prepare (_tmp10_, NULL, NULL);
	contacts_store_check_call_capabilities (self, NULL, NULL);
	_g_object_unref0 (backend_store);
	return obj;
}


static void
contacts_store_class_init (ContactsStoreClass * klass)
{
	contacts_store_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ContactsStorePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_store_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_contacts_store_set_property;
	G_OBJECT_CLASS (klass)->constructor = contacts_store_constructor;
	G_OBJECT_CLASS (klass)->finalize = contacts_store_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_AGGREGATOR_PROPERTY, contacts_store_properties[CONTACTS_STORE_AGGREGATOR_PROPERTY] = g_param_spec_object ("aggregator", "aggregator", "aggregator", FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_BACKEND_STORE_PROPERTY, contacts_store_properties[CONTACTS_STORE_BACKEND_STORE_PROPERTY] = g_param_spec_object ("backend-store", "backend-store", "backend-store", FOLKS_TYPE_BACKEND_STORE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_CALLER_ACCOUNT_PROPERTY, contacts_store_properties[CONTACTS_STORE_CALLER_ACCOUNT_PROPERTY] = g_param_spec_object ("caller-account", "caller-account", "caller-account", tp_account_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_IS_QUIESCENT_PROPERTY, contacts_store_properties[CONTACTS_STORE_IS_QUIESCENT_PROPERTY] = g_param_spec_boolean ("is-quiescent", "is-quiescent", "is-quiescent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_IS_PREPARED_PROPERTY, contacts_store_properties[CONTACTS_STORE_IS_PREPARED_PROPERTY] = g_param_spec_boolean ("is-prepared", "is-prepared", "is-prepared", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	contacts_store_signals[CONTACTS_STORE_CHANGED_SIGNAL] = g_signal_new ("changed", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, CONTACTS_TYPE_CONTACT);
	contacts_store_signals[CONTACTS_STORE_ADDED_SIGNAL] = g_signal_new ("added", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, CONTACTS_TYPE_CONTACT);
	contacts_store_signals[CONTACTS_STORE_REMOVED_SIGNAL] = g_signal_new ("removed", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, CONTACTS_TYPE_CONTACT);
	contacts_store_signals[CONTACTS_STORE_QUIESCENT_SIGNAL] = g_signal_new ("quiescent", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	contacts_store_signals[CONTACTS_STORE_PREPARED_SIGNAL] = g_signal_new ("prepared", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	contacts_store_signals[CONTACTS_STORE_EDS_PERSONA_STORE_CHANGED_SIGNAL] = g_signal_new ("eds-persona-store-changed", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
contacts_store_instance_init (ContactsStore * self)
{
	self->priv = CONTACTS_STORE_GET_PRIVATE (self);
	self->priv->_caller_account = NULL;
}


static void
contacts_store_finalize (GObject * obj)
{
	ContactsStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_STORE, ContactsStore);
	_g_object_unref0 (self->priv->_aggregator);
	_g_object_unref0 (self->priv->contacts);
	_g_object_unref0 (self->dont_suggest_link);
	_g_object_unref0 (self->priv->_caller_account);
	G_OBJECT_CLASS (contacts_store_parent_class)->finalize (obj);
}


GType
contacts_store_get_type (void)
{
	static volatile gsize contacts_store_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_store_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContactsStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsStore), 0, (GInstanceInitFunc) contacts_store_instance_init, NULL };
		GType contacts_store_type_id;
		contacts_store_type_id = g_type_register_static (G_TYPE_OBJECT, "ContactsStore", &g_define_type_info, 0);
		g_once_init_leave (&contacts_store_type_id__volatile, contacts_store_type_id);
	}
	return contacts_store_type_id__volatile;
}


static void
_vala_contacts_store_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	ContactsStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_STORE, ContactsStore);
	switch (property_id) {
		case CONTACTS_STORE_AGGREGATOR_PROPERTY:
		g_value_set_object (value, contacts_store_get_aggregator (self));
		break;
		case CONTACTS_STORE_BACKEND_STORE_PROPERTY:
		g_value_set_object (value, contacts_store_get_backend_store (self));
		break;
		case CONTACTS_STORE_CALLER_ACCOUNT_PROPERTY:
		g_value_set_object (value, contacts_store_get_caller_account (self));
		break;
		case CONTACTS_STORE_IS_QUIESCENT_PROPERTY:
		g_value_set_boolean (value, contacts_store_get_is_quiescent (self));
		break;
		case CONTACTS_STORE_IS_PREPARED_PROPERTY:
		g_value_set_boolean (value, contacts_store_get_is_prepared (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_contacts_store_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	ContactsStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_STORE, ContactsStore);
	switch (property_id) {
		case CONTACTS_STORE_AGGREGATOR_PROPERTY:
		contacts_store_set_aggregator (self, g_value_get_object (value));
		break;
		case CONTACTS_STORE_CALLER_ACCOUNT_PROPERTY:
		contacts_store_set_caller_account (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



