/* contacts-settings.c generated by valac 0.40.4, the Vala compiler
 * generated from contacts-settings.vala, do not modify */

/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>


#define CONTACTS_TYPE_SETTINGS (contacts_settings_get_type ())
#define CONTACTS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_SETTINGS, ContactsSettings))
#define CONTACTS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_SETTINGS, ContactsSettingsClass))
#define CONTACTS_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_SETTINGS))
#define CONTACTS_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_SETTINGS))
#define CONTACTS_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_SETTINGS, ContactsSettingsClass))

typedef struct _ContactsSettings ContactsSettings;
typedef struct _ContactsSettingsClass ContactsSettingsClass;
typedef struct _ContactsSettingsPrivate ContactsSettingsPrivate;
enum  {
	CONTACTS_SETTINGS_0_PROPERTY,
	CONTACTS_SETTINGS_DID_INITIAL_SETUP_PROPERTY,
	CONTACTS_SETTINGS_SORT_ON_SURNAME_PROPERTY,
	CONTACTS_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* contacts_settings_properties[CONTACTS_SETTINGS_NUM_PROPERTIES];

#define CONTACTS_TYPE_APP (contacts_app_get_type ())
#define CONTACTS_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_APP, ContactsApp))
#define CONTACTS_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_APP, ContactsAppClass))
#define CONTACTS_IS_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_APP))
#define CONTACTS_IS_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_APP))
#define CONTACTS_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_APP, ContactsAppClass))

typedef struct _ContactsApp ContactsApp;
typedef struct _ContactsAppClass ContactsAppClass;

struct _ContactsSettings {
	GSettings parent_instance;
	ContactsSettingsPrivate * priv;
};

struct _ContactsSettingsClass {
	GSettingsClass parent_class;
};


static gpointer contacts_settings_parent_class = NULL;

GType contacts_settings_get_type (void) G_GNUC_CONST;
#define CONTACTS_SETTINGS_DID_INITIAL_SETUP_KEY "did-initial-setup"
#define CONTACTS_SETTINGS_SORT_ON_SURNAME_KEY "sort-on-surname"
#define CONTACTS_SETTINGS_WINDOW_WIDTH_KEY "window-width"
#define CONTACTS_SETTINGS_WINDOW_HEIGHT_KEY "window-height"
#define CONTACTS_SETTINGS_WINDOW_MAXIMIZED_KEY "window-maximized"
GType contacts_app_get_type (void) G_GNUC_CONST;
ContactsSettings* contacts_settings_new (ContactsApp* app);
ContactsSettings* contacts_settings_construct (GType object_type,
                                               ContactsApp* app);
void contacts_settings_bind_default (ContactsSettings* self,
                                     const gchar* key,
                                     GObject* object,
                                     const gchar* property);
gboolean contacts_settings_get_did_initial_setup (ContactsSettings* self);
void contacts_settings_set_did_initial_setup (ContactsSettings* self,
                                              gboolean value);
gboolean contacts_settings_get_sort_on_surname (ContactsSettings* self);
void contacts_settings_set_sort_on_surname (ContactsSettings* self,
                                            gboolean value);
static void _vala_contacts_settings_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_contacts_settings_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);


ContactsSettings*
contacts_settings_construct (GType object_type,
                             ContactsApp* app)
{
	ContactsSettings * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (app != NULL, NULL);
	_tmp0_ = g_application_get_application_id ((GApplication*) app);
	_tmp1_ = _tmp0_;
	self = (ContactsSettings*) g_object_new (object_type, "schema-id", _tmp1_, NULL);
	return self;
}


ContactsSettings*
contacts_settings_new (ContactsApp* app)
{
	return contacts_settings_construct (CONTACTS_TYPE_SETTINGS, app);
}


void
contacts_settings_bind_default (ContactsSettings* self,
                                const gchar* key,
                                GObject* object,
                                const gchar* property)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	g_return_if_fail (object != NULL);
	g_return_if_fail (property != NULL);
	g_settings_bind ((GSettings*) self, key, object, property, G_SETTINGS_BIND_DEFAULT);
}


gboolean
contacts_settings_get_did_initial_setup (ContactsSettings* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = g_settings_get_boolean ((GSettings*) self, CONTACTS_SETTINGS_DID_INITIAL_SETUP_KEY);
	return result;
}


void
contacts_settings_set_did_initial_setup (ContactsSettings* self,
                                         gboolean value)
{
	g_return_if_fail (self != NULL);
	g_settings_set_boolean ((GSettings*) self, CONTACTS_SETTINGS_DID_INITIAL_SETUP_KEY, value);
	g_object_notify_by_pspec ((GObject *) self, contacts_settings_properties[CONTACTS_SETTINGS_DID_INITIAL_SETUP_PROPERTY]);
}


gboolean
contacts_settings_get_sort_on_surname (ContactsSettings* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = g_settings_get_boolean ((GSettings*) self, CONTACTS_SETTINGS_SORT_ON_SURNAME_KEY);
	return result;
}


void
contacts_settings_set_sort_on_surname (ContactsSettings* self,
                                       gboolean value)
{
	g_return_if_fail (self != NULL);
	g_settings_set_boolean ((GSettings*) self, CONTACTS_SETTINGS_SORT_ON_SURNAME_KEY, value);
	g_object_notify_by_pspec ((GObject *) self, contacts_settings_properties[CONTACTS_SETTINGS_SORT_ON_SURNAME_PROPERTY]);
}


static void
contacts_settings_class_init (ContactsSettingsClass * klass)
{
	contacts_settings_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_contacts_settings_set_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_SETTINGS_DID_INITIAL_SETUP_PROPERTY, contacts_settings_properties[CONTACTS_SETTINGS_DID_INITIAL_SETUP_PROPERTY] = g_param_spec_boolean ("did-initial-setup", "did-initial-setup", "did-initial-setup", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_SETTINGS_SORT_ON_SURNAME_PROPERTY, contacts_settings_properties[CONTACTS_SETTINGS_SORT_ON_SURNAME_PROPERTY] = g_param_spec_boolean ("sort-on-surname", "sort-on-surname", "sort-on-surname", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
contacts_settings_instance_init (ContactsSettings * self)
{
}


/**
 * Provides a convenient interface to deal with the settings.
 */
GType
contacts_settings_get_type (void)
{
	static volatile gsize contacts_settings_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContactsSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsSettings), 0, (GInstanceInitFunc) contacts_settings_instance_init, NULL };
		GType contacts_settings_type_id;
		contacts_settings_type_id = g_type_register_static (g_settings_get_type (), "ContactsSettings", &g_define_type_info, 0);
		g_once_init_leave (&contacts_settings_type_id__volatile, contacts_settings_type_id);
	}
	return contacts_settings_type_id__volatile;
}


static void
_vala_contacts_settings_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	ContactsSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_SETTINGS, ContactsSettings);
	switch (property_id) {
		case CONTACTS_SETTINGS_DID_INITIAL_SETUP_PROPERTY:
		g_value_set_boolean (value, contacts_settings_get_did_initial_setup (self));
		break;
		case CONTACTS_SETTINGS_SORT_ON_SURNAME_PROPERTY:
		g_value_set_boolean (value, contacts_settings_get_sort_on_surname (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_contacts_settings_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	ContactsSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_SETTINGS, ContactsSettings);
	switch (property_id) {
		case CONTACTS_SETTINGS_DID_INITIAL_SETUP_PROPERTY:
		contacts_settings_set_did_initial_setup (self, g_value_get_boolean (value));
		break;
		case CONTACTS_SETTINGS_SORT_ON_SURNAME_PROPERTY:
		contacts_settings_set_sort_on_surname (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



